<template>
  <div id="breadcrumbs"></div>
</template>

<script>
import { contentbar } from '../contents';

// Create two dictionaries:
// `page_to_crumbs` maps a page suffix to a list of breadcrumbs
//    Example: "Einfuehrung/Editorische Prinzipien_Zitation.html" -> ["Texte", "Editorische Prinzipien", "Zitation"]
// `crumbs_to_page` maps a list of breadcrumbs to a page suffix
//    Example: ["Texte", "Editorische Prinzipien", "Zitation"] -> "Einfuehrung/Editorische Prinzipien_Zitation.html"
var path = [];
var page_to_crumbs = {}
var crumbs_to_page = {}
function get_crumbs(contentlist){
  for(var i = 0; i < contentlist.length; ++i){
    var contentitem = contentlist[i];
    var page = contentitem.link.substring(1);
    if(page.indexOf("?") > -1){
      page = page.substring(0, page.indexOf("?"));
    }
    var name = contentitem.text;
    path.push(name);
    page_to_crumbs[page] = [...path];
    crumbs_to_page[path] = page;
    if(contentitem.hasOwnProperty("children")){
      get_crumbs(contentitem.children);
    }
    path.pop();
  }
}
get_crumbs(contentbar);

export default {
  mounted() {
    var crumbs = page_to_crumbs[decodeURI(window.location.pathname).substring(1)];
    var links = [];
    for(var i = 0; i < crumbs.length; ++i){
      if(i == 0){
        links.push('<a class="sidebar-item sidebar-heading" href="/' + crumbs_to_page[crumbs.slice(0, i+1)] + '">' + crumbs[i] + '</a>');
      }
      else {
        links.push('<a class="sidebar-item" href="/' + crumbs_to_page[crumbs.slice(0, i+1)] + '">' + crumbs[i] + '</a>');
      }
    }
    document.getElementById("breadcrumbs").innerHTML = links.join(' <span class="arrow right"></span>');
  }
}
</script>

<style lang="scss" scoped>
@import "../styles/components/breadcrumbs.scss";
</style>
